#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$06-jun-2010 12:34:44$'
#
# <one line to give the program's name and a brief idea of what it does.>
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import ConfigParser
import os

class Ini:
	def __init__(self,inifile):
		self.inifile=inifile
		#
		self.version = '2'
		self.latitude = 39.4702393
		self.longitude = -0.3768049
		self.location = 'Valencia, España'
		self.temperature = 'C'
		#
		if os.path.exists(inifile)==False:
			self.write()

	def read(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Def'):
			self.write()
		else:
			version = ini.get('Def','version')
			if len(version)<0 or int(version)<int(self.version):
				self.version = '2'
				self.latitude = 39.4702393
				self.longitude = -0.3768049 
				self.location = 'Valencia, España'
				self.temperature = 'C'				
			else:
				self.version = ini.get('Def','version')
				self.latitude = float(ini.get('Def','latitude'))
				self.longitude= float(ini.get('Def','longitude'))
				self.location = ini.get('Def','location')
				self.temperature = ini.get('Def','temperature')

	def write(self):
		ini=ConfigParser.ConfigParser()
		ini.read(self.inifile)
		if not ini.has_section('Def'):
			ini.add_section('Def')
		ini.set('Def','version',self.version)
		ini.set('Def','latitude',self.latitude)
		ini.set('Def','longitude',self.longitude)
		ini.set('Def','location',self.location)		
		ini.set('Def','temperature',self.temperature)		
		with open(self.inifile,'wb') as writefile:
			ini.write(writefile)

	def get_version(self):
		return self.version

	def set_version(self,version):
		self.version = version

	def get_latitude(self):
		return self.latitude

	def set_latitude(self,latitude):
		self.latitude = latitude

	def get_longitude(self):
		return self.longitude

	def set_longitude(self,longitude):
		self.longitude = longitude

	def get_location(self):
		return self.location
		
	def set_location(self,location):
		self.location = location
		
	def get_temperature(self):
		return self.temperature
		
	def set_temperature(self,temperature):
		self.temperature = temperature
		
