#! /usr/bin/python
# -*- coding: iso-8859-15 -*-
#
__author__='atareao'
__date__ ='$30/10/2010'
#
# My-Weather-Indicator
# An indicator to show the weather
#
# Adding keybiding
#
# Copyright (C) 2010 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gobject
import gtk
import appindicator
import urllib2
import pynotify
import locale
import gettext
import glib
import time
import preferences
import dbus
from datetime import datetime
from forecastw import FC
from preferences import CM
from preferences import load_key
from preferences import is_key
import commwi
import goweapi
from configurator import GConf
from encoderapi import Encoder

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

IDIOMA = locale.getlocale()[0][:2]

encoder = Encoder()

class MWI():	
	def __init__(self):
		if dbus.SessionBus().request_name('es.atareao.MyWeatherIndicator') != dbus.bus.REQUEST_NAME_REPLY_PRIMARY_OWNER:
			print "application already running"
			exit(0)		
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
				p.run()
				p.destroy()
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','C')
		self.temperature = load_key('temperature','Silla, Spain')
		'''
		Categorias:
		* CATEGORY_APPLICATION_STATUS
		* CATEGORY_COMMUNICATIONS
		* CATEGORY_SYSTEM_SERVICES
		* CATEGORY_HARDWARE
		* CATEGORY_OTHER
		'''
		self.indicator = appindicator.Indicator('My-Weather-Indicator', 'My-Weather-Indicator', appindicator.CATEGORY_APPLICATION_STATUS)
		#
		#
		#
		#self.indicator.set_icon(icon_enabled)
		#self.indicator.set_attention_icon(icon_disabled)
		'''
		Estados:
		* STATUS_PASSIVE : The icon is hidden
		* STATUS_ACTIVE : The icon is visible
		* STATUS_ATTENTION : The icon changes to the attention icon, requesting some kind of interaction with the user
		'''	
		self.indicator.set_status(appindicator.STATUS_ACTIVE)
		#
		self.current_conditions = None
		self.set_menu()
		#
		glib.timeout_add_seconds(600, self.work)
	
	def set_menu(self):
		self.menu = gtk.Menu()	
		#
		weather = goweapi.get_weather_from_google(lat = float(self.latitude), lon = float(self.longitude), hl = IDIOMA)
		temporal_current_conditions = weather['current_conditions']
		forecast = weather['forecasts']
		conditions_changed = False
		if len(temporal_current_conditions)!=0:
			if self.current_conditions == None \
			or temporal_current_conditions['temp_c'] != self.current_conditions['temp_c'] \
			or temporal_current_conditions['humidity'] != self.current_conditions['humidity'] \
			or temporal_current_conditions['wind_condition'] != self.current_conditions['wind_condition'] \
			or temporal_current_conditions['condition'] != self.current_conditions['condition'] \
			or temporal_current_conditions['icon'] != self.current_conditions['icon']:
				conditions_changed = True
			self.current_conditions = temporal_current_conditions
			#
			data=[]
			self_menu_data=[]
			data.append(_('Location')+': '+self.location)
			data.append(_('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature)
			data.append(self.current_conditions['humidity'])
			data.append(self.current_conditions['wind_condition'])
			data.append(self.current_conditions['condition'])
			for element in data:
				gmi=gtk.MenuItem(element)
				self.menu.append(gmi)
				gmi.show()
			#
			self.menu_separator1=gtk.MenuItem()
			self.menu_forecast=gtk.MenuItem(_('Forecast'))
			self.menu_set_location=gtk.MenuItem(_('Preferences'))
			self.menu_refresh_weather=gtk.MenuItem(_('Refresh weather'))
			self.menu_exit=gtk.MenuItem(_('Exit'))
			self.menu_separator2=gtk.MenuItem()
			self.menu_about=gtk.MenuItem(_('About'))
			self.menu_image=gtk.ImageMenuItem()
			#***************************************************************
			hora = datetime.time(datetime.now()).hour
			if hora < 7 or hora > 19:
				icon_file = self.current_conditions['icon'].split('/')[-1:][0][:-4]+'_n.png'
			else:
				icon_file = self.current_conditions['icon'].split('/')[-1:][0][:-3]+'png'
			if os.path.exists(os.path.join(commwi.IMGDIR,icon_file)) == False:
				icon_file = os.path.join(commwi.IMGDIR,'na.png')
			else:
				icon_file = os.path.join(commwi.IMGDIR,icon_file)
			#***************************************************************
			imagen = gtk.Image()
			imagen.set_from_file(icon_file)
			self.menu_image.set_image(imagen)
			#
			self.menu.append(self.menu_separator1)
			self.menu.append(self.menu_forecast)
			self.menu.append(self.menu_set_location)
			self.menu.append(self.menu_refresh_weather)
			self.menu.append(self.menu_exit)
			self.menu.append(self.menu_separator2)
			self.menu.append(self.menu_about)
			self.menu.append(self.menu_image)	
			if conditions_changed == True:
				msg = _('Conditions in')+' '+self.location+'\n'
				msg += _('Temperature')+': '+cambia(self.current_conditions['temp_c'],self.temperature)+' º'+self.temperature+'\n'
				msg += self.current_conditions['humidity']+'\n'
				msg += self.current_conditions['wind_condition']+'\n'			
				msg += self.current_conditions['condition']
				self.notification = pynotify.Notification ('My-Weather-Indicator',msg,icon_file)
				self.notification.show()
			self.indicator.set_icon(icon_file)
			self.indicator.set_status (appindicator.STATUS_ACTIVE)
			#
			self.menu_separator2.show()
			self.menu_forecast.show()
			self.menu_set_location.show()
			self.menu_refresh_weather.show()
			self.menu_exit.show()
			self.menu_separator1.show()
			self.menu_about.show()
			self.menu_image.show()
			#
			self.menu_forecast.connect('activate',self.menu_forecast_response)
			self.menu_set_location.connect('activate',self.menu_set_location_response)
			self.menu_refresh_weather.connect('activate', self.menu_refresh_weather_response)
			self.menu_exit.connect('activate', self.menu_exit_response)
			self.menu_about.connect('activate', self.menu_about_response)
			#menu.show()
			self.indicator.set_menu(self.menu)
		
	def work(self):
		self.set_menu()
		return True
		
	def menu_forecast_response(self,widget):
		self.menu_forecast.set_visible(False)
		fc = FC()
		fc.run()
		fc.destroy()
		self.menu_forecast.set_visible(True)

	def menu_set_location_response(self,widget):
		self.menu_set_location.set_visible(False)
		p=preferences.CM()
		p.run()
		p.destroy()
		while is_key('latitude') == False or is_key('longitude') == False or is_key('location') == False or is_key('temperature') == False:
				p=preferences.CM()
				p.run()
				p.destroy()
		self.latitude = load_key('latitude','39.361346')
		self.longitude = load_key('longitude','-0.4126143')
		self.location = load_key('location','C')
		self.temperature = load_key('temperature','Silla, Spain')
		self.menu_set_location.set_visible(True)
		self.set_menu()
		
	def menu_refresh_weather_response(self,widget):
		self.set_menu()

	def menu_exit_response(self,widget):
		exit(0)

	def menu_about_response(self,widget):
		ad=gtk.AboutDialog()
		ad.set_name('My-Weather-Indicator')
		ad.set_version('0.3.2.6')
		ad.set_copyright('Copyrignt (c) 2011\nLorenzo Carbonell')
		ad.set_comments(_('A weather indicator'))
		ad.set_license(_(''+
		'This program is free software: you can redistribute it and/or modify it\n'+
		'under the terms of the GNU General Public License as published by the\n'+
		'Free Software Foundation, either version 3 of the License, or (at your option)\n'+
		'any later version.\n\n'+
		'This program is distributed in the hope that it will be useful, but\n'+
		'WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY\n'+
		'or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for\n'+
		'more details.\n\n'+
		'You should have received a copy of the GNU General Public License along with\n'+
		'this program.  If not, see <http://www.gnu.org/licenses/>.'))		
		ad.set_website('http://www.atareao.es')
		ad.set_website_label('http://www.atareao.es')
		ad.set_authors(['Pascal De Vuyst <pascal.devuyst@gmail.com>','Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		ad.set_translator_credits('Antoni Sperka <https://launchpad.net/~antek1004-gmail>\n\
Clemente Junior <https://launchpad.net/~clmnt-jr>\n\
David Štancl <https://launchpad.net/~dstancl-dstancl>\n\
Fabio Lambertini <https://launchpad.net/~fabio-lambe>\n\
Fitoschido <fitoschido@gmail.com>\n\
Giorgio Grappa <https://launchpad.net/~j-monteagudo>\n\
Jiri Grönroos <https://launchpad.net/~jiri-gronroos>\n\
Lorenzo Carbonell <https://launchpad.net/~lorenzo-carbonell>\n\
NykO18 <https://launchpad.net/~nyko18>\n\
Pascal De Vuyst <pascal.devuyst@gmail.com>\n\
R33D3M33R <https://launchpad.net/~r33d3m33r>\n\
Xose M Lamas <https://launchpad.net/~xmgz>\n\
zeugma <https://launchpad.net/~sunder67>')
		ad.set_documenters(['Lorenzo Carbonell <lorenzo.carbonell.cerezo@gmail.com>'])
		#ad.set_logo(logo)
		#ad.set_logo_icon_name(icon_name)
		ad.set_program_name('My-Weather-Indicator')
		ad.run()
		ad.hide()

def redondea(valor):
	valor = valor * 10.0
	return int(valor)/10.0

def cambia(valor,a):
	valor = float(valor)
	if a=='F':
		return str(redondea(valor*9.0/5.0 + 32.0))
	elif a == 'K':
		return str(redondea(valor+273.15))
	return str(valor)

if __name__ == "__main__":
	mwi=MWI()
	gtk.main()
