#! /usr/bin/python
# -*- coding: iso-8859-1 -*-
#
__author__="atareao"
__date__ ="$29-ene-2011$"
#
# <from numbers to letters.>
#
# Copyright (C) 2011 Lorenzo Carbonell
# lorenzo.carbonell.cerezo@gmail.com
#
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#
#
import os
import gtk
import locale
import gettext
import commwi
import geocodeapi
from searchlocation import SL
from configurator import GConf

locale.setlocale(locale.LC_ALL, '')
gettext.bindtextdomain(commwi.APP, commwi.LANGDIR)
gettext.textdomain(commwi.APP)
_ = gettext.gettext

APPDIR = commwi.APPDIR

ROOT = '/apps/my-weather-indicator/options/'

def is_key(key):
	gconfi = GConf()
	PATH = ROOT+key
	valor = gconfi.get_key(PATH)
	if valor == None:
		return False
	return True

def load_key(key,defecto):
	gconfi = GConf()
	PATH = ROOT+key
	try:
		valor = gconfi.get_key(PATH)
		if valor == None:
			gconfi.set_key(PATH,defecto)
			return defecto
		return valor
	except ValueError:
		gconfi.set_key(PATH,defecto)
	return defecto


class CM(gtk.Dialog): # needs GTK, Python, Webkit-GTK
	def __init__(self):
		self.location = None
		#
		gtk.Dialog.__init__(self,'my-weather-indicator | '+_('Preferences'),None)
		self.set_position(gtk.WIN_POS_CENTER_ALWAYS)
		self.set_default_size(400, 150)
		self.connect('destroy', self.close_cancel)
		#
		self.vbox1 = gtk.VBox(spacing = 5)
		self.vbox1.set_border_width(5)
		self.get_content_area().add(self.vbox1)
		#***************************************************************
		self.hbox0 = gtk.HBox(spacing = 5)
		self.hbox0.set_border_width(5)
		self.vbox1.add(self.hbox0)
		#***************************************************************
		self.vbox2 = gtk.VBox(spacing = 5)
		self.vbox2.set_border_width(5)
		self.hbox0.add(self.vbox2)
		#***************************************************************
		self.hbox1 = gtk.HBox(spacing = 5)
		self.hbox1.set_border_width(5)
		self.vbox2.add(self.hbox1)
		#
		self.label1 = gtk.Label(_('Latitude')+':')
		self.hbox1.pack_start(self.label1,False,False)
		#
		self.entry1 = gtk.Entry()
		self.hbox1.pack_start(self.entry1,True,True)
		#***************************************************************
		self.hbox2 = gtk.HBox(spacing = 5)
		self.hbox2.set_border_width(5)
		self.vbox2.add(self.hbox2)
		#
		self.label2 = gtk.Label(_('longitude')+':')
		self.hbox2.pack_start(self.label2,False,False)
		#
		self.entry2 = gtk.Entry()
		self.hbox2.pack_start(self.entry2,True,True)
		#***************************************************************
		self.button0 = gtk.Button(_('Search Location'))		
		self.button0.connect('clicked',self.search_location)
		self.hbox0.pack_start(self.button0,False,False)		
		#***************************************************************
		self.hbox3 = gtk.HBox(spacing = 5)
		self.hbox3.set_border_width(5)
		self.vbox1.add(self.hbox3)
		#
		self.label3 = gtk.Label(_('Temperature')+':')
		self.hbox3.pack_start(self.label3,False,False)
		#
		self.liststore3 = gtk.ListStore(str,str)
		self.liststore3.append([_('Celsius'),'C'])
		self.liststore3.append([_('Fahrenheit'),'F'])
		self.liststore3.append([_('Kelvin'),'K'])
		self.combobox3 = gtk.ComboBox(self.liststore3)
		cell3 = gtk.CellRendererText()
		self.combobox3.pack_start(cell3, True)
		self.combobox3.add_attribute(cell3, 'text', 0)  
		self.hbox3.pack_start(self.combobox3,True,True)
		#***************************************************************
		self.checkbutton1 = gtk.CheckButton(_('Autostart'))		
		self.vbox1.pack_start(self.checkbutton1,True,True)		
		#***************************************************************
		self.hbox4 = gtk.HBox(spacing = 5)
		self.hbox4.set_border_width(5)
		self.vbox1.add(self.hbox4)
		#
		self.button1 = gtk.Button(_('Ok'))
		self.button1.connect('clicked',self.close_ok)
		self.hbox4.pack_start(self.button1,True,True)
		#
		self.button2 = gtk.Button(_('Cancel'))
		self.button2.connect('clicked',self.close_cancel)
		self.hbox4.pack_start(self.button2,True,True)
		#***************************************************************
		if os.path.exists(os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator.py.desktop")):
			self.checkbutton1.set_active(True)
		#
		self.show_all()
		#
		self.load_preferences()
		#
		
	def close_application(self, widget, event, data=None):
		self.hide()
		self.ok = False
		
	def search_location(self,widget):
		sl = SL(self,self.entry1.get_text(),self.entry2.get_text())
		if sl.run() == gtk.RESPONSE_ACCEPT:
			self.latitude = str(sl.get_latitude())
			self.longitude = str(sl.get_longitude())
			self.location = sl.get_location()
			self.entry1.set_text(self.latitude)
			self.entry2.set_text(self.longitude)
		else:
			self.latitude = None
			self.longitude = None
			self.location = None
		sl.destroy()
			
		
	def close_ok(self,widget):
		if self.location == None:
			direction = geocodeapi.get_inv_direction(self.entry1.get_text(),self.entry2.get_text())
			if direction['locality'] != None:
				self.location = direction['locality']+', '+direction['country']
			else:
				self.location = direction['country']			
		self.save_preferences()
		filestart = os.path.join(os.getenv("HOME"),".config/autostart/my-weather-indicator.py.desktop")
		if self.checkbutton1.get_active():
			if not os.path.exists(filestart):
				os.symlink('/usr/share/my-weather-indicator/my-weather-indicator.py.desktop',filestart)
		else:		
			if os.path.exists(filestart):
				os.remove(filestart)
		self.ok = True
		self.hide()

	def close_cancel(self,widget):
		self.ok = False
		self.hide()
	
	def load_preferences(self):
		self.entry1.set_text(load_key('latitude','39.361346'))
		self.entry2.set_text(load_key('longitude','-0.4126143'))
		self.temperature = load_key('temperature','C')
		if self.temperature == 'C':
			self.combobox3.set_active(0)
		elif self.temperature == 'F':
			self.combobox3.set_active(1)
		elif self.temperature == 'K':
			self.combobox3.set_active(2)
		
	def save_preferences(self):
		gconfi = GConf()	
		gconfi.set_key('/apps/my-weather-indicator/options/latitude',self.entry1.get_text())
		gconfi.set_key('/apps/my-weather-indicator/options/longitude',self.entry2.get_text())
		gconfi.set_key('/apps/my-weather-indicator/options/temperature',self.liststore3.get_value(self.combobox3.get_active_iter(),1))
		gconfi.set_key('/apps/my-weather-indicator/options/location',self.location)
		
if __name__ == "__main__":	
	cm = CM()
	cm.run()
	exit(0)
